Subject: [rddp] URGENT: Local Peer and Remote Peer - Do we need RDDP changes?

From: [email-masked]
Date: Wed, 21 Sep 2005 14:09:41 -0400

We have an issue that requires some immediate attention.  I was under
the impression that the issues with Local Peer and Remote Peer usage
found in review of the iSER draft did not require any changes to
the RDMAP and DDP drafts.  I have now been informed that this is not
a completely obvious or universally held viewpoint.  We need to decide
whether to change these drafts in fairly short order.

The issue is that depending on context, the terms "Local Peer" and
"Remote Peer" in the RDMAP and DDP drafts may refer to either the
RDMAP/DDP protocol implementation or the ULP that is using RDMAP/DDP.
See below for a longer explanation that Mike Ko originally wrote last
week.

We need to choose one of the following two alternatives:
(1) The intent of each usage is clear from context.  An implementer
	will have no difficulty understanding what was meant.  No
	text change is needed.
(2) The intent of each usage is difficult to determine.  An implementer
	may be confused and misunderstand what was meant.  The text
	needs to be clarified.
Please post your view on which alternative should be chosen and why
to the list in short order, as I want to close this issue (determine
rough consensus of the WG) sometime next week.

>From a timing perspective, if the drafts do not need modification, I
should be able to get them into AD (and possibly IESG) review during
October.  If revisions are needed, between demands on author time and
the upcoming Vancouver meeting, this probably won't happen to the
revised drafts until late November.  The overall IETF perspective on
this is that getting content right matters - if this is broken, it
needs to be fixed, and a 4-6 week delay is not an unreasonable side
effect.

Thanks,
--David

> In the course of updating the iSER draft, we found that the usage of the 
> terms "Local Peer" and "Remote Peer" as they relate to Advertisement is 
> not quite correct in both the RDMAP draft and the DDP draft.
> 
> In the RDMAP draft, "Local Peer" is defined as "The RDMA/DDP protocol 
> implementation on the local end of the connection" and "Remote Peer" is 
> similarly defined as "The RDMA/DDP protocol implementation on the opposite

> end of the connection".  Under the definition of Advertisement, it states 
> that "advertisement of Tagged Buffer information is not defined by 
> RDMA/DDP and is left to the ULP".  For example, it is the iSER layer at 
> the local node that advertises the STag to the iSER layer at the remote 
> node by embedding the STag in a Send Message and the RDMAP/DDP layers send

> the Send Message with no knowledge of the embedded STag.  However, In the 
> RDMAP draft, Advertisement is defined as "the act of informing a Remote 
> Peer that a local RDMA Buffer is available to it. A Node makes available 
> an RDMA Buffer for incoming RDMA Read or RDMA Write access by informing 
> its RDMA/DDP peer of the Tagged Buffer identifiers ...".  This should be 
> changed to "the act of informing the ULP of a Remote Peer that a local 
> RDMA Buffer is available to it.  A Node makes available an RDMA Buffer for

> incoming RDMA Read or RDMA Write access by informing the ULP of its Remote

> Peer of the Tagged Buffer identifiers ..."
> 
> Similarly, 
> 
> The definition of Tagged Buffer should refer to the "ULP of the Remote 
> Peer" instead of just "Remote Peer" and the revised definition should be 
> "A buffer that is explicitly Advertised to the ULP of the Remote Peer 
> through exchange of an STag, Tagged Offset, and length".
> 
> The definition of Untagged Buffer should refer to the "ULP of the Remote 
> Peer" instead of just "Remote Peer" and the revised definition should be
"A 
> buffer that is not explicitly Advertised to the ULP of the Remote Peer."
> 
> "ULP Buffer" is currently defined as "A buffer owned above the RDMAP Layer

> and advertised to the RDMAP Layer either as a Tagged Buffer or an Untagged

> ULP Buffer".  This definition is unclear since it does not mention whether

> the RDMAP Layer refers to the local node or the remote node.  If the RDMAP

> Layer refers to the remote node, then it is incorrect to state that the 
> Untagged buffer is advertised.  If the RDMAP is the local node, then usage

> of the term "advertised" is incorrect since it is used in reference to a 
> remote node.  Perhaps it should be defined as "A buffer owned above the 
> RDMAP Layer and made available to the RDMAP Layer either as a Tagged 
> Buffer or an Untagged Buffer."
> 
> Mike

----------------------------------------------------
David L. Black, Senior Technologist
EMC Corporation, 176 South St., Hopkinton, MA  01748
+1 (508) 293-7953             FAX: +1 (508) 293-7786
[email-masked]        Mobile: +1 (978) 394-7754
----------------------------------------------------

_______________________________________________
rddp mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/rddp

---

From: "Caitlin Bestler" <[email-masked]>
Date: Wed, 21 Sep 2005 17:00:54 -0700

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]] On 
> Behalf Of [email-masked]
> Sent: Wednesday, September 21, 2005 11:10 AM
> To: [email-masked]; [email-masked]
> Subject: [rddp] URGENT: Local Peer and Remote Peer - Do we 
> need RDDP changes?
> Importance: High
> 
> We have an issue that requires some immediate attention.  I 
> was under the impression that the issues with Local Peer and 
> Remote Peer usage found in review of the iSER draft did not 
> require any changes to the RDMAP and DDP drafts.  I have now 
> been informed that this is not a completely obvious or 
> universally held viewpoint.  We need to decide whether to 
> change these drafts in fairly short order.
> 
> The issue is that depending on context, the terms "Local 
> Peer" and "Remote Peer" in the RDMAP and DDP drafts may refer 
> to either the RDMAP/DDP protocol implementation or the ULP 
> that is using RDMAP/DDP.
> See below for a longer explanation that Mike Ko originally 
> wrote last week.
> 

After rescanning the drafts, I am thoroughly convinced that
each usage of "Remote Peer" or "Local Peer" in the text is
unambiguous. The terms are generally used to refer to the
consumer of RDMA services. The terms are frequently used
in conjunction with the specific layer, i.e. "Remote Peer
ULP". The few cases where there is no explicit clarification
the subject is clear in context, for example that the Local
Peer is a consumer of RDMA service (and hence is the ULP).

The definitions are the closest there is to misleading text.
But there is definitely nothing that would leave any question
in the minds of any implementer as to what layer was responsible
for implementing any specific behavior described.